package einsc;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

/**
 */
public class GeneratorTest {
    public static void main(String[] args) {
        try {
            InputStreamReader in = args.length < 1 ? new InputStreamReader(System.in)
                : new FileReader(args[0]);
            PrintWriter out = args.length < 2 ? new PrintWriter(System.out)
                : new PrintWriter(new FileWriter(args[1]));

            Parser parser = new Parser(in);
            Tree tree = parser.parse();
            in.close();
            Analyzer analyzer = new Analyzer();
            analyzer.analyze(tree);
            if (Report.errors > 0)
                System.err.println(Report.errors + " errors found." );
            else {
                Generator generator = new Generator(analyzer);
                generator.gen(tree);
                generator.code.write(out);
            }
        } catch (IOException e) {
            Report.fail(e.getMessage());
        }
    }
}
