/*  einsc -- a compiler for eins
 *    Test application for the scanner
 *
 *    Matthias Zenger, Michel Schinz, Philippe Altherr
 *    $Id: ParserTest.java,v 1.1 2005/03/29 14:01:37 dragos Exp $
 */

package einsc;

import java.io.*;

/** A small parser test class; it reads in a file and prints out
 *  every/the first syntax error that is found. Programs which
 *  do not yield error messages are supposed to be syntactically
 *  correct.
 *
 *  usage: java einsc.ParserTest <file.eins>
 */
public class ParserTest {
    public static void main(String[] args) {
        try {
            Parser p = new Parser(new FileReader(args[0]));
            p.parse();
            p.close();
        } catch (IOException e) {
            Report.fail(e.getMessage());
        }
    }
}
