/*  einsc -- a compiler for eins
 *    Error management
 *
 *    Matthias Zenger, Michel Schinz, Philippe Altherr
 *    $Id: Report.java,v 1.1 2005/03/29 14:01:36 dragos Exp $
 */
package einsc;


/** This class provides functionality for printing error messages.
 */
class Report {

    /** Number of errors.
     */
    public static int errors;

    /** Prints out an error message.
     */
    public static void error(String message) {
        errors++;
        System.err.println(message);
    }

    /** Prints out an error message.
     */
    public static void error(int position, String message) {
        errors++;
        print(position, message);
    }

    /** Prints out an error message and stops the program execution.
     */
    public static void fail(String message) {
        error(message);
        System.exit(-1);
    }

    /** Prints out an error message and stops the program execution.
     */
    public static void fail(int position, String message) {
        error(position, message);
        System.exit(-1);
    }

    /** Imprime la position et le message passes en argument. */
    private static void print(int position, String message) {
        System.err.println(Position.line(position) + ":" +
                           Position.column(position) + ": " +
                           message);
    }
}
